#!/usr/bin/env python
#testscript.py
#Test script for ClientAPI
#
#Maintained by W.Yang
#
import ClientAPI
import pickle
import xml.dom.minidom
import exceptions
import base64

class foo:
    def setdata(self,value):
        self.bar = value

        self.time = 'now'
    def display(self):
        print self.bar
        print self.time
        
myconn = ClientAPI.serverconnection()

while 1:
    print 'Please choose the following options:'
    print '0. exit'
    print '1.open database'
    print '2. create a project'
    print '3. create a job'
    print '4. set item'
    print '5. get item'
    print '6.list project'
    print '7.list job'
    print '8. set dingbat'
    print '9. get dingbat'
    print '10. delete dingbat'
    print '11. get description of dingbat'
    print '12. close database'
    print '13. open a project'
    print '14. print MySQLdb version'
    print '15.Delete a project'
    print '16.Check if db open'
    print '17.ListItem'
    print '18.Update data'
    print '19. Get jobid'
    print '20.Get jobname'
    
    op = raw_input('your option: ')  
                 
    if op == '1':
      #  host = raw_input('please enter the host name:')
      #  user = raw_input('                 user name:')
      #  pw = raw_input('                   password:')
      #  dbname = raw_input('               database name:')
        host = 'localhost'
        user = 'admin'
        pw = 'admin'
        dbname = 'ProjectHistory'
        try:
            myconn.OpenDB(host,user,pw,dbname)
        
     #   print a.status
     #   print a.result
        except exceptions.Exception,e:
            print str(e)
            
    elif op == '2':
        pro = raw_input('please enter project name:')
        try:
            a = myconn.NewProject(pro)
            print a
        except RuntimeError,e:
             print str(e)
        except ValueError,e:
            print str(e)
        except exceptions.Exception,e:
            print str(e)
            
    elif op == '3':
        pid = raw_input('please enter project name:')
        job = raw_input('             job name:')
        try:
            a = myconn.NewJob(pid,job)
            print a
        except RuntimeError,e:
            print str(e)
        except ValueError,e:
            print str(e)
        except exceptions.Exception,e:
            print str(e)
            
    elif op == '4':
        jobid = raw_input('please enter job id:')
        name = raw_input('              item name:')
        value = raw_input('             item value:')
        try:
            a = myconn.SetData(jobid,name,value)
            print a
        except ValueError,e:
            print 'value error: '+str(e)
        except RuntimeError,e:
            print 'runtime error:'+ str(e)
        except exceptions.Exception,e:
            print 'exception :'+str(e)          

    elif op == '5':
        jobid = raw_input('please enter job id:')
        name = raw_input('              item name:')
        try:
            a = myconn.GetData(jobid,name)
            print a
       
        except RuntimeError,e:
            print str(e)
        except ValueError,e:
            print 'value error: '+str(e)
        except exceptions.Exception,e:
            print str(e)
            
    elif op == '6':
        try:
            a = myconn.ListProjects()
            print a

        except RuntimeError,e:
            print str(e)
        except Exception, e:
            print str(e)
        except exceptions.Exception,e:
            print str(e)
            
    elif op == '7':
        pname = raw_input('please enter project name:')
        try:            
            a = myconn.ListJobs(pname)
            print a
        except RuntimeError,e:
            print str(e)
        except exceptions.Exception,e:
            print str(e)
            
    elif op == '8':
        f = foo()
        f.setdata('abc')
        p = pickle.dumps(f)
        jobid = raw_input('please enter job id:')
        name = raw_input('              dingbat name:')
        desc = raw_input('              dingbat description:')
        type = raw_input('              dingbat type:')

        try:
           # print type(jobid)
            a = myconn.ImportDingbat(jobid,name,desc,type,p)
            print a
            print p
        except ValueError,e:
            print 'catch value error: %s ' % str(e)
        except RuntimeError,e:
            print 'here'
            print str(e)
        except exceptions.Exception,e:
            print 'there'
            print str(e)
            
    elif op == '9':
        jobid = raw_input('please enter job id:')
        name = raw_input('              dingbat name:')
        try:
          # print type(jobid)
           value = myconn.ExportDingbat(jobid,name)
    
           object = pickle.loads(str(value))
           object.display()
           desc = myconn.DescribeDingbat(jobid,name)
           print desc
        except RuntimeError, e:
            print 'Runtime error: '+str(e)
        except exceptions.Exception,e:
           print 'catch exception: %s' % str(e)
        except exceptions.Exception,e:
            print str(e) 
    
    elif op == '10':
        jobid = raw_input('please enter job id:')
        name = raw_input('              dingbat name:')
        try:
            a = myconn.DeleteDingbat(jobid,name)
            print a
        except RuntimeError,e:
            print str(e)
        except exceptions.Exception,e:
            print str(e)
            
    elif op == '11':
        jobid = raw_input('please enter job id:')
        name = raw_input('              dingbat name:')
        try:
            a = myconn.DescribeDingbat(jobid,name)
            print a
        except RuntimeError,e:
            print str(e)
        except exceptions.Exception,e:
            print str(e)
            
    elif op == '12':
        try:
            a = myconn.CloseDB()
            print a
        except RuntimeError,e:
            print str(e)
        except exceptions.Exception,e:
            print str(e)
            
    elif op == '0':
        break

    elif op == '13':
        projectname = raw_input('please enter project name:')
        try:
            a = myconn.GetProject(projectname)
            print a
        except RuntimeError,e:
            print str(e)
        except exceptions.Exception,e:
            print str(e)
            
    elif op == '14':
        try:
            a = myconn.Version()
            print a
        except RuntimeError,e:
            print str(e)
        except exceptions.Exception,e:
            print str(e)
            
    elif op == '15':
        projectname = raw_input('Please enter project name:')
        try:
            a = myconn.DeleteProject(projectname)
            print a
        except RuntimeError,e:
            print str(e)
        except exceptions.Exception,e:
            print str(e)
            
    elif op == '16':
        try:
            a = myconn.IsOpen()
            print a
        except RuntimeError,e:
            print str(e)
        except exceptions.Exception,e:
            print str(e)
            
    elif op == '17':
        jobid = raw_input('please enter job id?')
        
        a = myconn.ListItems(jobid)
        print a
    elif op == '18':
        factid = raw_input('please  enter fact id?')
        value = raw_input('value?')
        
        print myconn.UpdateData(factid,value)
    elif op == '19':
        projectname = raw_input('please enter projectname?')
        jobname = raw_input(' jobname?')

        print myconn.GetJobid(projectname,jobname)
    elif op == '20':
        jobid = raw_input('please enter jobid?')
        print myconn.GetJobname(jobid)

    else:
        print 'please try again! option(0--15)'
    
   
